export class PriorityQueue {
    constructor() {
        this.queue = [];
        this.sorter = null;
    }
    static make(opts) {
        const T = PriorityQueue;
        const t = new PriorityQueue();
        opts = opts || { sorter: null };
        for (const key in T) {
            const prop = Object.getOwnPropertyDescriptor(T, key);
            const kv = Object.entries(T).find(([k, v]) => k === key);
            if (prop && kv) {
                Object.assign(t, { [key]: kv[1] });
            }
        }
        Object.assign(t, { sorter: opts.sorter || T.default_sorter });
        return t;
    }
    push(value, cost) {
        var _a;
        const item = { value, cost };
        this.queue.push(item);
        this.queue.sort((_a = this.sorter) !== null && _a !== void 0 ? _a : undefined);
    }
    pop() {
        return this.queue.shift();
    }
    empty() {
        return this.queue.length === 0;
    }
}
PriorityQueue.default_sorter = (a, b) => {
    return a.cost - b.cost;
};
//# sourceMappingURL=priority-queue.js.map